package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseCoatColor;
import com.ruoyi.web.base.service.IBaseCoatColorService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 毛色 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-coat-color")
public class BaseCoatColorController {
    @Autowired
    private IBaseCoatColorService baseCoatColorService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("毛色管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseCoatColor baseCoatColor, HttpServletRequest request) throws Exception  {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseCoatColorService.count(new QueryWrapper<BaseCoatColor>().eq("org_id",loginOrgId).eq("coat_num", baseCoatColor.getCoatNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseCoatColor.setOrgId(loginOrgId);
        baseCoatColor.setCreateBy(getUsername());
        return success(baseCoatColorService.save(baseCoatColor));
    }

    @ApiOperation("毛色管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseCoatColor baseCoatColor, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseCoatColorService.count(new QueryWrapper<BaseCoatColor>().ne("id",baseCoatColor.getId()).eq("org_id",loginOrgId).eq("coat_num", baseCoatColor.getCoatNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseCoatColor.setUpdateBy(getUsername());
        return success(baseCoatColorService.updateById(baseCoatColor));
    }

    @ApiOperation("毛色管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseCoatColorService.removeById(s);
        }
        return success();
    }

    @ApiOperation("毛色管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseCoatColorService.list(new QueryWrapper<BaseCoatColor>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("毛色管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseCoatColorService.page(new Page<BaseCoatColor>(pageNum,pageSize),new QueryWrapper<BaseCoatColor>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("毛色管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseCoatColorService.getById(id));
    }
}
